using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace ActionDemo
{
	public class ActionForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu mmAction;
		private System.Windows.Forms.MenuItem miFile;
		private System.Windows.Forms.MenuItem miNewChild;
		private System.Windows.Forms.MenuItem mi1;
		private System.Windows.Forms.MenuItem miClose;
		private SharpPlus.Action.ActionList alActions;
		private SharpPlus.Action.Action actNewChild;
		private SharpPlus.Action.WindowCloseAction WindowCloseAction;
		private System.Windows.Forms.MenuItem miWindow;
		private System.Windows.Forms.MenuItem miArrange;
		private System.Windows.Forms.MenuItem miCascade;
		private System.Windows.Forms.MenuItem miTileHort;
		private System.Windows.Forms.MenuItem miTileVert;
		private SharpPlus.Action.WindowArrangeAction WindowArrangeAction;
		private SharpPlus.Action.WindowCascadeAction WindowCascadeAction;
		private SharpPlus.Action.WindowTileHorizontalAction WindowTileHorizontalAction;
		private SharpPlus.Action.WindowTileVerticalAction WindowTileVerticalAction;
		private SharpPlus.Action.WindowMinimizeAllAction WindowMinimizeAllAction;
		private System.Windows.Forms.MenuItem mi2;
		private System.Windows.Forms.MenuItem miMinizeAll;
		private System.Windows.Forms.ToolBar tlbAction;
		private System.Windows.Forms.ToolBarButton tbtnCut;
		private System.Windows.Forms.ToolBarButton tbtnCopy;
		private System.Windows.Forms.ToolBarButton tbtnPaste;
		private System.Windows.Forms.ToolBarButton tbtnSelectAll;
		private SharpPlus.Action.EditClearAction EditClearAction;
		private SharpPlus.Action.EditCopyAction EditCopyAction;
		private SharpPlus.Action.EditCutAction EditCutAction;
		private SharpPlus.Action.EditPasteAction EditPasteAction;
		private SharpPlus.Action.EditSelectAllAction EditSelectAllAction;
		private SharpPlus.Action.EditUndoAction EditUndoAction;
		private System.Windows.Forms.MenuItem miEdit;
		private System.Windows.Forms.MenuItem miUndo;
		private System.Windows.Forms.MenuItem mi3;
		private System.Windows.Forms.MenuItem miCut;
		private System.Windows.Forms.MenuItem miCopy;
		private System.Windows.Forms.MenuItem miPaste;
		private System.Windows.Forms.MenuItem miClear;
		private System.Windows.Forms.MenuItem mi4;
		private System.Windows.Forms.MenuItem miSelectAll;
		private System.Windows.Forms.MenuItem miHelp;
		private System.Windows.Forms.MenuItem miHome;
		private SharpPlus.Action.BrowseUrlAction BrowseUrlAction;
		private System.Windows.Forms.MenuItem miPopChild;
		private System.Windows.Forms.ContextMenu cmChild;
		private System.Windows.Forms.ImageList ilImages;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.ComponentModel.IContainer components;

		public ActionForm()
		{
			InitializeComponent();

		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Designer generated code
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ActionForm));
			this.mmAction = new System.Windows.Forms.MainMenu();
			this.miFile = new System.Windows.Forms.MenuItem();
			this.miNewChild = new System.Windows.Forms.MenuItem();
			this.mi1 = new System.Windows.Forms.MenuItem();
			this.miClose = new System.Windows.Forms.MenuItem();
			this.miEdit = new System.Windows.Forms.MenuItem();
			this.miUndo = new System.Windows.Forms.MenuItem();
			this.mi3 = new System.Windows.Forms.MenuItem();
			this.miCut = new System.Windows.Forms.MenuItem();
			this.miCopy = new System.Windows.Forms.MenuItem();
			this.miPaste = new System.Windows.Forms.MenuItem();
			this.miClear = new System.Windows.Forms.MenuItem();
			this.mi4 = new System.Windows.Forms.MenuItem();
			this.miSelectAll = new System.Windows.Forms.MenuItem();
			this.miWindow = new System.Windows.Forms.MenuItem();
			this.miArrange = new System.Windows.Forms.MenuItem();
			this.miCascade = new System.Windows.Forms.MenuItem();
			this.miTileHort = new System.Windows.Forms.MenuItem();
			this.miTileVert = new System.Windows.Forms.MenuItem();
			this.mi2 = new System.Windows.Forms.MenuItem();
			this.miMinizeAll = new System.Windows.Forms.MenuItem();
			this.miHelp = new System.Windows.Forms.MenuItem();
			this.miHome = new System.Windows.Forms.MenuItem();
			this.alActions = new SharpPlus.Action.ActionList();
			this.actNewChild = new SharpPlus.Action.Action();
			this.WindowCloseAction = new SharpPlus.Action.WindowCloseAction();
			this.EditUndoAction = new SharpPlus.Action.EditUndoAction();
			this.EditCutAction = new SharpPlus.Action.EditCutAction();
			this.EditCopyAction = new SharpPlus.Action.EditCopyAction();
			this.EditPasteAction = new SharpPlus.Action.EditPasteAction();
			this.EditClearAction = new SharpPlus.Action.EditClearAction();
			this.EditSelectAllAction = new SharpPlus.Action.EditSelectAllAction();
			this.WindowArrangeAction = new SharpPlus.Action.WindowArrangeAction();
			this.WindowCascadeAction = new SharpPlus.Action.WindowCascadeAction();
			this.WindowTileHorizontalAction = new SharpPlus.Action.WindowTileHorizontalAction();
			this.WindowTileVerticalAction = new SharpPlus.Action.WindowTileVerticalAction();
			this.WindowMinimizeAllAction = new SharpPlus.Action.WindowMinimizeAllAction();
			this.BrowseUrlAction = new SharpPlus.Action.BrowseUrlAction();
			this.ilImages = new System.Windows.Forms.ImageList(this.components);
			this.tbtnCut = new System.Windows.Forms.ToolBarButton();
			this.tbtnCopy = new System.Windows.Forms.ToolBarButton();
			this.tbtnPaste = new System.Windows.Forms.ToolBarButton();
			this.tbtnSelectAll = new System.Windows.Forms.ToolBarButton();
			this.miPopChild = new System.Windows.Forms.MenuItem();
			this.tlbAction = new System.Windows.Forms.ToolBar();
			this.cmChild = new System.Windows.Forms.ContextMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			((System.ComponentModel.ISupportInitialize)(this.alActions)).BeginInit();
			this.SuspendLayout();
			// 
			// mmAction
			// 
			this.mmAction.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.miFile,
																					 this.miEdit,
																					 this.menuItem1,
																					 this.miWindow,
																					 this.miHelp});
			// 
			// miFile
			// 
			this.miFile.Index = 0;
			this.miFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																				   this.miNewChild,
																				   this.mi1,
																				   this.miClose});
			this.miFile.Text = "File";
			// 
			// miNewChild
			// 
			this.alActions.SetAction(this.miNewChild, this.actNewChild);
			this.miNewChild.Index = 0;
			this.miNewChild.Text = "New MdiChild";
			// 
			// mi1
			// 
			this.mi1.Index = 1;
			this.mi1.Text = "-";
			// 
			// miClose
			// 
			this.alActions.SetAction(this.miClose, this.WindowCloseAction);
			this.miClose.Index = 2;
			this.miClose.Text = "Close";
			// 
			// miEdit
			// 
			this.miEdit.Index = 1;
			this.miEdit.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																				   this.miUndo,
																				   this.mi3,
																				   this.miCut,
																				   this.miCopy,
																				   this.miPaste,
																				   this.miClear,
																				   this.mi4,
																				   this.miSelectAll});
			this.miEdit.Text = "Edit";
			// 
			// miUndo
			// 
			this.alActions.SetAction(this.miUndo, this.EditUndoAction);
			this.miUndo.Index = 0;
			this.miUndo.Shortcut = System.Windows.Forms.Shortcut.CtrlZ;
			this.miUndo.Text = "Undo";
			// 
			// mi3
			// 
			this.mi3.Index = 1;
			this.mi3.Text = "-";
			// 
			// miCut
			// 
			this.alActions.SetAction(this.miCut, this.EditCutAction);
			this.miCut.Index = 2;
			this.miCut.Shortcut = System.Windows.Forms.Shortcut.CtrlX;
			this.miCut.Text = "Cut";
			// 
			// miCopy
			// 
			this.alActions.SetAction(this.miCopy, this.EditCopyAction);
			this.miCopy.Index = 3;
			this.miCopy.Shortcut = System.Windows.Forms.Shortcut.CtrlC;
			this.miCopy.Text = "Copy";
			// 
			// miPaste
			// 
			this.alActions.SetAction(this.miPaste, this.EditPasteAction);
			this.miPaste.Index = 4;
			this.miPaste.Shortcut = System.Windows.Forms.Shortcut.CtrlV;
			this.miPaste.Text = "Paste";
			// 
			// miClear
			// 
			this.alActions.SetAction(this.miClear, this.EditClearAction);
			this.miClear.Index = 5;
			this.miClear.Text = "Clear";
			// 
			// mi4
			// 
			this.mi4.Index = 6;
			this.mi4.Text = "-";
			// 
			// miSelectAll
			// 
			this.alActions.SetAction(this.miSelectAll, this.EditSelectAllAction);
			this.miSelectAll.Index = 7;
			this.miSelectAll.Shortcut = System.Windows.Forms.Shortcut.CtrlA;
			this.miSelectAll.Text = "Select All";
			// 
			// miWindow
			// 
			this.miWindow.Index = 3;
			this.miWindow.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.miArrange,
																					 this.miCascade,
																					 this.miTileHort,
																					 this.miTileVert,
																					 this.mi2,
																					 this.miMinizeAll});
			this.miWindow.Text = "Window";
			// 
			// miArrange
			// 
			this.alActions.SetAction(this.miArrange, this.WindowArrangeAction);
			this.miArrange.Index = 0;
			this.miArrange.Text = "Arrange Icon";
			// 
			// miCascade
			// 
			this.alActions.SetAction(this.miCascade, this.WindowCascadeAction);
			this.miCascade.Index = 1;
			this.miCascade.Text = "Cascade Windows";
			// 
			// miTileHort
			// 
			this.alActions.SetAction(this.miTileHort, this.WindowTileHorizontalAction);
			this.miTileHort.Index = 2;
			this.miTileHort.Text = "Tile Horizontal";
			// 
			// miTileVert
			// 
			this.alActions.SetAction(this.miTileVert, this.WindowTileVerticalAction);
			this.miTileVert.Index = 3;
			this.miTileVert.Text = "Tile VerticalAction";
			// 
			// mi2
			// 
			this.mi2.Index = 4;
			this.mi2.Text = "-";
			// 
			// miMinizeAll
			// 
			this.alActions.SetAction(this.miMinizeAll, this.WindowMinimizeAllAction);
			this.miMinizeAll.Index = 5;
			this.miMinizeAll.Text = "Minimize All";
			// 
			// miHelp
			// 
			this.miHelp.Index = 4;
			this.miHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																				   this.miHome});
			this.miHelp.Text = "Help";
			// 
			// miHome
			// 
			this.alActions.SetAction(this.miHome, this.BrowseUrlAction);
			this.miHome.Index = 0;
			this.miHome.Text = "HomePage";
			// 
			// alActions
			// 
			this.alActions.Actions.Add(this.actNewChild);
			this.alActions.Actions.Add(this.WindowCloseAction);
			this.alActions.Actions.Add(this.WindowArrangeAction);
			this.alActions.Actions.Add(this.WindowCascadeAction);
			this.alActions.Actions.Add(this.WindowTileHorizontalAction);
			this.alActions.Actions.Add(this.WindowTileVerticalAction);
			this.alActions.Actions.Add(this.WindowMinimizeAllAction);
			this.alActions.Actions.Add(this.EditClearAction);
			this.alActions.Actions.Add(this.EditCopyAction);
			this.alActions.Actions.Add(this.EditCutAction);
			this.alActions.Actions.Add(this.EditPasteAction);
			this.alActions.Actions.Add(this.EditSelectAllAction);
			this.alActions.Actions.Add(this.EditUndoAction);
			this.alActions.Actions.Add(this.BrowseUrlAction);
			this.alActions.ImageList = this.ilImages;
			// 
			// actNewChild
			// 
			this.actNewChild.Caption = "New MdiChild";
			this.actNewChild.Category = "File";
			this.actNewChild.ExecuteAction += new System.EventHandler(this.actNewChild_ExecuteAction);
			// 
			// WindowCloseAction
			// 
			this.WindowCloseAction.Caption = "Close";
			this.WindowCloseAction.Category = "Window";
			this.WindowCloseAction.Form = this;
			// 
			// EditUndoAction
			// 
			this.EditUndoAction.Caption = "Undo";
			this.EditUndoAction.Category = "Edit";
			this.EditUndoAction.ShortCut = System.Windows.Forms.Shortcut.CtrlZ;
			// 
			// EditCutAction
			// 
			this.EditCutAction.Caption = "Cut";
			this.EditCutAction.Category = "Edit";
			this.EditCutAction.ImageIndex = 1;
			this.EditCutAction.ShortCut = System.Windows.Forms.Shortcut.CtrlX;
			this.EditCutAction.Tooltip = "Cut";
			// 
			// EditCopyAction
			// 
			this.EditCopyAction.Caption = "Copy";
			this.EditCopyAction.Category = "Edit";
			this.EditCopyAction.ImageIndex = 0;
			this.EditCopyAction.ShortCut = System.Windows.Forms.Shortcut.CtrlC;
			this.EditCopyAction.Tooltip = "Copy";
			// 
			// EditPasteAction
			// 
			this.EditPasteAction.Caption = "Paste";
			this.EditPasteAction.Category = "Edit";
			this.EditPasteAction.ImageIndex = 2;
			this.EditPasteAction.ShortCut = System.Windows.Forms.Shortcut.CtrlV;
			this.EditPasteAction.Tooltip = "Paste";
			// 
			// EditClearAction
			// 
			this.EditClearAction.Caption = "Clear";
			this.EditClearAction.Category = "Edit";
			// 
			// EditSelectAllAction
			// 
			this.EditSelectAllAction.Caption = "Select All";
			this.EditSelectAllAction.Category = "Edit";
			this.EditSelectAllAction.ImageIndex = 3;
			this.EditSelectAllAction.ShortCut = System.Windows.Forms.Shortcut.CtrlA;
			this.EditSelectAllAction.Tooltip = "Select All";
			// 
			// WindowArrangeAction
			// 
			this.WindowArrangeAction.Caption = "Arrange Icon";
			this.WindowArrangeAction.Category = "Window";
			// 
			// WindowCascadeAction
			// 
			this.WindowCascadeAction.Caption = "Cascade Windows";
			this.WindowCascadeAction.Category = "Window";
			// 
			// WindowTileHorizontalAction
			// 
			this.WindowTileHorizontalAction.Caption = "Tile Horizontal";
			this.WindowTileHorizontalAction.Category = "Window";
			// 
			// WindowTileVerticalAction
			// 
			this.WindowTileVerticalAction.Caption = "Tile VerticalAction";
			this.WindowTileVerticalAction.Category = "Window";
			// 
			// WindowMinimizeAllAction
			// 
			this.WindowMinimizeAllAction.Caption = "Minimize All";
			this.WindowMinimizeAllAction.Category = "Window";
			// 
			// BrowseUrlAction
			// 
			this.BrowseUrlAction.Caption = "HomePage";
			this.BrowseUrlAction.Category = "Internet";
			this.BrowseUrlAction.Url = "http://www.sharpplus.com";
			// 
			// ilImages
			// 
			this.ilImages.ImageSize = new System.Drawing.Size(16, 16);
			this.ilImages.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("ilImages.ImageStream")));
			this.ilImages.TransparentColor = System.Drawing.Color.FromArgb(((System.Byte)(254)), ((System.Byte)(0)), ((System.Byte)(254)));
			// 
			// tbtnCut
			// 
			this.alActions.SetAction(this.tbtnCut, this.EditCutAction);
			this.tbtnCut.ImageIndex = 1;
			this.tbtnCut.ToolTipText = "Cut";
			// 
			// tbtnCopy
			// 
			this.alActions.SetAction(this.tbtnCopy, this.EditCopyAction);
			this.tbtnCopy.ImageIndex = 0;
			this.tbtnCopy.ToolTipText = "Copy";
			// 
			// tbtnPaste
			// 
			this.alActions.SetAction(this.tbtnPaste, this.EditPasteAction);
			this.tbtnPaste.ImageIndex = 2;
			this.tbtnPaste.ToolTipText = "Paste";
			// 
			// tbtnSelectAll
			// 
			this.alActions.SetAction(this.tbtnSelectAll, this.EditSelectAllAction);
			this.tbtnSelectAll.ImageIndex = 3;
			this.tbtnSelectAll.ToolTipText = "Select All";
			// 
			// miPopChild
			// 
			this.alActions.SetAction(this.miPopChild, this.actNewChild);
			this.miPopChild.Index = 0;
			this.miPopChild.OwnerDraw = true;
			this.miPopChild.Text = "New MdiChild";
			// 
			// tlbAction
			// 
			this.tlbAction.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						 this.tbtnCut,
																						 this.tbtnCopy,
																						 this.tbtnPaste,
																						 this.tbtnSelectAll});
			this.tlbAction.DropDownArrows = true;
			this.tlbAction.ImageList = this.ilImages;
			this.tlbAction.Location = new System.Drawing.Point(0, 0);
			this.tlbAction.Name = "tlbAction";
			this.tlbAction.ShowToolTips = true;
			this.tlbAction.Size = new System.Drawing.Size(406, 28);
			this.tlbAction.TabIndex = 1;
			// 
			// cmChild
			// 
			this.cmChild.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.miPopChild});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 2;
			this.menuItem1.Text = "List";
			this.menuItem1.Click += new System.EventHandler(this.menuItem1_Click);
			// 
			// ActionForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(406, 360);
			this.ContextMenu = this.cmChild;
			this.Controls.Add(this.tlbAction);
			this.IsMdiContainer = true;
			this.Menu = this.mmAction;
			this.Name = "ActionForm";
			this.Text = "Action Demo";
			((System.ComponentModel.ISupportInitialize)(this.alActions)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new ActionForm());
		}

		private void actNewChild_ExecuteAction(object sender, System.EventArgs e)
		{
			ChildForm frm=new ChildForm();
			frm.MdiParent=this;
			frm.Show();
		}

		private void menuItem1_Click(object sender, System.EventArgs e)
		{
            new ListForm().ShowDialog();		
		}

	}
}
