//AuthorSharpPlus Software Corp.
//Action Designer Dialog
//Date2004-12-3

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.ComponentModel.Design.Serialization;
using System.Windows.Forms;

namespace SharpPlus.Action.Design
{
	internal class DsgnForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel pnlList;
		private System.Windows.Forms.ListBox lbCategory;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.ListBox lbAction;
		private System.Windows.Forms.ToolBarButton tbtnNewAction;
		private System.Windows.Forms.ImageList ilAction;
		private System.Windows.Forms.ToolBarButton tbtnExit;
		private System.Windows.Forms.ToolBar tbAction;
		private DsgnPropertyGrid pgAction;
		private System.Windows.Forms.ToolBarButton toolBarButton1;
		private System.Windows.Forms.ToolBarButton tbtnDelete;
		private System.Windows.Forms.Timer timerUpdate;
		private System.Windows.Forms.ToolBarButton tbtnStdAction;
		private System.Windows.Forms.ToolBarButton tbtnUp;
		private System.Windows.Forms.ToolBarButton tbtnDown;
		private System.Windows.Forms.ToolBarButton tbtn1;
		private System.Windows.Forms.Splitter spl1;
		private System.ComponentModel.IContainer components;

		public DsgnForm()
		{
			InitializeComponent();

		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Designer generated code
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(DsgnForm));
			this.pnlList = new System.Windows.Forms.Panel();
			this.lbAction = new System.Windows.Forms.ListBox();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.lbCategory = new System.Windows.Forms.ListBox();
			this.tbAction = new System.Windows.Forms.ToolBar();
			this.tbtnNewAction = new System.Windows.Forms.ToolBarButton();
			this.tbtnStdAction = new System.Windows.Forms.ToolBarButton();
			this.tbtnDelete = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton1 = new System.Windows.Forms.ToolBarButton();
			this.tbtnUp = new System.Windows.Forms.ToolBarButton();
			this.tbtnDown = new System.Windows.Forms.ToolBarButton();
			this.tbtn1 = new System.Windows.Forms.ToolBarButton();
			this.tbtnExit = new System.Windows.Forms.ToolBarButton();
			this.ilAction = new System.Windows.Forms.ImageList(this.components);
			this.pgAction = new SharpPlus.Action.Design.DsgnPropertyGrid(this.components);
			this.timerUpdate = new System.Windows.Forms.Timer(this.components);
			this.spl1 = new System.Windows.Forms.Splitter();
			this.pnlList.SuspendLayout();
			this.SuspendLayout();
			// 
			// pnlList
			// 
			this.pnlList.Controls.Add(this.lbAction);
			this.pnlList.Controls.Add(this.splitter1);
			this.pnlList.Controls.Add(this.lbCategory);
			this.pnlList.Controls.Add(this.tbAction);
			this.pnlList.Dock = System.Windows.Forms.DockStyle.Top;
			this.pnlList.Location = new System.Drawing.Point(0, 0);
			this.pnlList.Name = "pnlList";
			this.pnlList.Size = new System.Drawing.Size(576, 200);
			this.pnlList.TabIndex = 0;
			// 
			// lbAction
			// 
			this.lbAction.Dock = System.Windows.Forms.DockStyle.Fill;
			this.lbAction.ItemHeight = 12;
			this.lbAction.Location = new System.Drawing.Point(163, 28);
			this.lbAction.Name = "lbAction";
			this.lbAction.Size = new System.Drawing.Size(413, 172);
			this.lbAction.TabIndex = 3;
			this.lbAction.SelectedIndexChanged += new System.EventHandler(this.lbAction_SelectedIndexChanged);
			// 
			// splitter1
			// 
			this.splitter1.Location = new System.Drawing.Point(160, 28);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(3, 172);
			this.splitter1.TabIndex = 2;
			this.splitter1.TabStop = false;
			// 
			// lbCategory
			// 
			this.lbCategory.Dock = System.Windows.Forms.DockStyle.Left;
			this.lbCategory.ItemHeight = 12;
			this.lbCategory.Location = new System.Drawing.Point(0, 28);
			this.lbCategory.Name = "lbCategory";
			this.lbCategory.Size = new System.Drawing.Size(160, 172);
			this.lbCategory.TabIndex = 1;
			this.lbCategory.SelectedIndexChanged += new System.EventHandler(this.lbCategory_SelectedIndexChanged);
			// 
			// tbAction
			// 
			this.tbAction.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						this.tbtnNewAction,
																						this.tbtnStdAction,
																						this.tbtnDelete,
																						this.toolBarButton1,
																						this.tbtnUp,
																						this.tbtnDown,
																						this.tbtn1,
																						this.tbtnExit});
			this.tbAction.DropDownArrows = true;
			this.tbAction.ImageList = this.ilAction;
			this.tbAction.Location = new System.Drawing.Point(0, 0);
			this.tbAction.Name = "tbAction";
			this.tbAction.ShowToolTips = true;
			this.tbAction.Size = new System.Drawing.Size(576, 28);
			this.tbAction.TabIndex = 0;
			this.tbAction.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.tbAction_ButtonClick);
			// 
			// tbtnNewAction
			// 
			this.tbtnNewAction.ImageIndex = 0;
			this.tbtnNewAction.ToolTipText = "New Action";
			// 
			// tbtnStdAction
			// 
			this.tbtnStdAction.ImageIndex = 3;
			this.tbtnStdAction.ToolTipText = "New Standard Action";
			// 
			// tbtnDelete
			// 
			this.tbtnDelete.ImageIndex = 2;
			this.tbtnDelete.ToolTipText = "Delete";
			// 
			// toolBarButton1
			// 
			this.toolBarButton1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// tbtnUp
			// 
			this.tbtnUp.ImageIndex = 4;
			this.tbtnUp.ToolTipText = "Up";
			// 
			// tbtnDown
			// 
			this.tbtnDown.ImageIndex = 5;
			this.tbtnDown.ToolTipText = "Down";
			// 
			// tbtn1
			// 
			this.tbtn1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// tbtnExit
			// 
			this.tbtnExit.ImageIndex = 1;
			this.tbtnExit.ToolTipText = "Exit";
			// 
			// ilAction
			// 
			this.ilAction.ImageSize = new System.Drawing.Size(16, 16);
			this.ilAction.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("ilAction.ImageStream")));
			this.ilAction.TransparentColor = System.Drawing.Color.FromArgb(((System.Byte)(254)), ((System.Byte)(0)), ((System.Byte)(254)));
			// 
			// pgAction
			// 
			this.pgAction.CommandsVisibleIfAvailable = true;
			this.pgAction.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pgAction.LargeButtons = false;
			this.pgAction.LineColor = System.Drawing.SystemColors.ScrollBar;
			this.pgAction.Location = new System.Drawing.Point(0, 200);
			this.pgAction.Name = "pgAction";
			this.pgAction.Size = new System.Drawing.Size(576, 333);
			this.pgAction.TabIndex = 1;
			this.pgAction.Text = "PropertyGrid";
			this.pgAction.ViewBackColor = System.Drawing.SystemColors.Window;
			this.pgAction.ViewForeColor = System.Drawing.SystemColors.WindowText;
			this.pgAction.SelectedObjectsChanged += new System.EventHandler(this.pgAction_SelectedObjectsChanged);
			this.pgAction.PropertyValueChanged += new System.Windows.Forms.PropertyValueChangedEventHandler(this.pgAction_PropertyValueChanged);
			// 
			// timerUpdate
			// 
			this.timerUpdate.Enabled = true;
			this.timerUpdate.Interval = 200;
			this.timerUpdate.Tick += new System.EventHandler(this.timerUpdate_Tick);
			// 
			// spl1
			// 
			this.spl1.Dock = System.Windows.Forms.DockStyle.Top;
			this.spl1.Location = new System.Drawing.Point(0, 200);
			this.spl1.Name = "spl1";
			this.spl1.Size = new System.Drawing.Size(576, 3);
			this.spl1.TabIndex = 2;
			this.spl1.TabStop = false;
			// 
			// DsgnForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.ClientSize = new System.Drawing.Size(576, 533);
			this.ControlBox = false;
			this.Controls.Add(this.spl1);
			this.Controls.Add(this.pgAction);
			this.Controls.Add(this.pnlList);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "DsgnForm";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Action Designer";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.DsgnForm_Closing);
			this.Load += new System.EventHandler(this.DsgnForm_Load);
			this.pnlList.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Property
		private ActionList _ActionList;
		public ActionList ActionList
		{
			get {return _ActionList;}
			set {
				_ActionList=value;
			}
		}
		#endregion

		public static void ShowActionDesigner(ActionList actList)
		{
			DsgnForm AForm=new DsgnForm();
			AForm.ActionList=actList;
			AForm.ShowDialog();			
		}

		private void tbAction_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			if (e.Button==this.tbtnExit)
			{
				this.Close();
			}
			else if (e.Button==this.tbtnNewAction)
			{
				//new Action
				NewAction();				
			}
			else if (e.Button==this.tbtnStdAction)
			{
				//new standard action
				NewStdAction();
			}
			else if (e.Button==this.tbtnDelete)
			{
				DeleteAction();
			}
			else if (e.Button==this.tbtnUp)
			{
				UpAction();
			}
			else if (e.Button==this.tbtnDown)
			{
				DownAction();
			}
		}

		private void UpAction()
		{
			//swap actions in list
			int index=lbAction.SelectedIndex;
			object old=lbAction.Items[index-1];
			object sel=lbAction.SelectedItem;
			lbAction.Items.Remove(old);
			lbAction.Items.Insert(index, old);
			//swap actions
			SwapActions(old, sel);
		}

		private void SwapActions(object old, object sel)
		{
			int oldindex=ActionList.Actions.IndexOf(old as Action);
			int selindex=ActionList.Actions.IndexOf(sel as Action);
			ActionList.Actions[selindex]=old as Action;
			ActionList.Actions[oldindex]=sel as Action;
		}

		private void DownAction()
		{
			//swap actions in list
			int index=lbAction.SelectedIndex;
			object old=lbAction.Items[index+1];
			object sel=lbAction.SelectedItem;
			lbAction.Items.Remove(old);
			lbAction.Items.Insert(index, old);
			//swap actions 
			SwapActions(old, sel);
		}

		private void NewStdAction()
		{
			StdActionForm frm=new StdActionForm();
			if (frm.ShowDialog()==DialogResult.OK)
			{
				Type ActionType=frm.ActionType;
				Action AAction=NewActionType(true, ActionType);
				this.RefreshActions();
			}
		}

		private void NewAction()
		{
			Action AAction=NewActionType(false, typeof(Action));
			lbAction.Items.Add(AAction);
			lbAction.SelectedItem=AAction;
		}

		private Action NewActionType(bool DefaultCategory, Type ActionType)
		{
            //Generate a unique name
			INameCreationService nameSrv=(INameCreationService)ActionList.Site.GetService(typeof(INameCreationService));
			IDesignerHost host=(IDesignerHost)ActionList.Site.GetService(typeof(IDesignerHost));

			string AName=nameSrv.CreateName(ActionList.Container, ActionType);
			Action AAction=(Action)host.CreateComponent(ActionType,AName);
			AAction.Caption=AName;
			if (!DefaultCategory)
				(AAction as Action).Category=GetCategory();

			ActionList.Actions.Add(AAction);
			return AAction;
		}

		private void DeleteAction()
		{
			Action AAction=lbAction.SelectedItem as Action;
			lbAction.Items.Remove(AAction);
			ActionList.Actions.Remove(AAction);
			//AAction.Dispose();
		}

		private string GetCategory()
		{
			if (lbCategory.SelectedIndex==0 || lbCategory.SelectedIndex==lbCategory.Items.Count-1)
				return "";
			return lbCategory.SelectedItem as string;
		}

		private void DsgnForm_Load(object sender, System.EventArgs e)
		{
			//hook ComponentChanged event
			IComponentChangeService chgSrv=(IComponentChangeService)ActionList.Site.GetService(typeof(IComponentChangeService));
			chgSrv.ComponentRename+=new ComponentRenameEventHandler(chgSrv_ComponentRename);

			chgSrv.ComponentChanged+=new ComponentChangedEventHandler(chgSrv_ComponentChanged);
			//get CategoryList
			this.RefreshActions();
		}

		private void RefreshActions()
		{
			try
			{
				this.pgAction.SelectedObject=null;
				Hashtable categories=new Hashtable(5);
				foreach (Action AAction in ActionList.Actions)
				{
					if (AAction.Category==string.Empty || categories.ContainsKey(AAction.Category))             
						continue;
					categories.Add(AAction.Category,null);
				}

				lbCategory.Items.Clear();
				foreach (string key in categories.Keys)
				{
					lbCategory.Items.Add(key);
				}
				lbCategory.Sorted=true;
				lbCategory.Sorted=false;
				lbCategory.Items.Insert(0,"[No Category]");
				lbCategory.Items.Add("[All Actions]");
				lbCategory.SelectedIndex=0;
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message);
			}
		}

		private void lbCategory_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			//get all actions of current Category
			string Key="";
			lbAction.Items.Clear();
			if (lbCategory.SelectedIndex==lbCategory.Items.Count-1)
			{
				//all Action
				foreach (Action AAction in ActionList.Actions)
				{
					lbAction.Items.Add(AAction);
				}
				return;
			}
			else if (lbCategory.SelectedIndex>0)
				Key=lbCategory.SelectedItem as String;
		    
			foreach (Action AAction in ActionList.Actions)
			{
				if (AAction.Category==Key)
					lbAction.Items.Add(AAction);
			}
		}

		private void lbAction_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			this.pgAction.SelectedObject=lbAction.SelectedItem;

		}

		private void pgAction_PropertyValueChanged(object s, System.Windows.Forms.PropertyValueChangedEventArgs e)
		{
            //if category is changed then refresh the list display
			if (e.ChangedItem.Label=="Category")
			{
				this.RefreshActions();
			}
			//Noticechange component's Name will not fire this event.
		}

		private void RefreshAction()
		{
#warning Todo:Modify Action's name without change the propertygrid's display
			//Refresh Action's Name
			int index=lbAction.SelectedIndex;
			object sel=lbAction.SelectedItem;
			lbAction.Items.RemoveAt(index);
			lbAction.Items.Insert(index, sel);
		}

		private void timerUpdate_Tick(object sender, System.EventArgs e)
		{
			this.tbtnDelete.Enabled=CanDeleteAction();
			this.tbtnUp.Enabled=CanUpAction();
			this.tbtnDown.Enabled=CanDownAction();
		}

		private bool CanDeleteAction()
		{
			return lbAction.SelectedIndex!=-1;
		}

		private bool CanUpAction()
		{
			return lbAction.SelectedIndex>0;
		}

		private bool CanDownAction()
		{
			return lbAction.SelectedIndex>-1 && lbAction.SelectedIndex<lbAction.Items.Count-1;
		}

		protected virtual void UpdatePropertyGridSite() 
		{
			pgAction.Site = null;
			IServiceProvider provider = GetPropertyGridServiceProvider();
			if(provider != null) 
			{
				pgAction.Site = new PgSite(provider, pgAction as IComponent);
				pgAction.PropertyTabs.AddTabType(typeof(System.Windows.Forms.Design.EventsTab));
			}
		}

		protected virtual IServiceProvider GetPropertyGridServiceProvider() 
		{
			object selObject = null;
			if(pgAction.SelectedObjects != null && pgAction.SelectedObjects.Length > 0) 
				selObject = pgAction.SelectedObjects[0];
			else selObject = pgAction.SelectedObject;
			if(selObject is Component) 
			{
				return (selObject as Component).Site;
			}
			return null;
		}

		private void pgAction_SelectedObjectsChanged(object sender, System.EventArgs e)
		{
			UpdatePropertyGridSite();
			//disable context command in Property Grid
			this.pgAction.CommandsVisibleIfAvailable=false;
			(pgAction as DsgnPropertyGrid).ShowEvents(true);

		}

		private class PgSite : ISite 
		{
			IServiceProvider sp;
			IComponent comp;
			public PgSite(IServiceProvider sp, IComponent comp) 
			{
				this.sp = sp;
				this.comp = comp;
			}
			IComponent ISite.Component 
			{
				get { return comp;}
			}
			IContainer ISite.Container 
			{
				get { return null; }
			}
			bool ISite.DesignMode 
			{
				get { return false; }
			}
			string ISite.Name 
			{
				get { return null; }
				set { }
			}
			object IServiceProvider.GetService(Type t) 
			{
				if(t.Equals(typeof(System.ComponentModel.Design.IDesignerHost)))
					return sp.GetService(t);
				return null;
			}
		}

		private void chgSrv_ComponentRename(object sender, ComponentRenameEventArgs e)
		{
			//the component's name was changed
			this.RefreshAction();
		}

		private void DsgnForm_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			IComponentChangeService chgSrv=(IComponentChangeService)ActionList.Site.GetService(typeof(IComponentChangeService));
			chgSrv.ComponentChanged-=new ComponentChangedEventHandler(chgSrv_ComponentChanged);
			chgSrv.ComponentRename-=new ComponentRenameEventHandler(chgSrv_ComponentRename);
		}

		private void chgSrv_ComponentChanged(object sender, ComponentChangedEventArgs e)
		{
#warning Todo:if user does not double click on event, we should not close the dialog.
			if (e.Member.DisplayName=="UpdateAction" || e.Member.DisplayName=="ExecuteAction")
			{
				//if new event handler, then close current dialog, show editor to edit event handler code
				if (e.NewValue==null)
				{
					//MessageBox.Show("Change event to null");
					return;
				}
				this.Close();
			}
		}
	}
}
