//AuthorSharpPlus Software Corp.
//improved PropertyGrid support edit control's event
//Date2004-12-4

using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Windows.Forms;
using System.Collections;
using System.Diagnostics;

namespace SharpPlus.Action.Design
{
	internal class DsgnPropertyGrid : System.Windows.Forms.PropertyGrid
	{
		private System.ComponentModel.Container components = null;

		public DsgnPropertyGrid(System.ComponentModel.IContainer container)
		{
			container.Add(this);
			InitializeComponent();

		}

		public DsgnPropertyGrid()
		{
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Event
		public void ShowEvents(bool show) 
		{
			ShowEventsButton(show);
		}

		protected virtual void ShowContextMenu() 
		{
			if(Site == null) return;
			IMenuCommandService menu = (IMenuCommandService)Site.GetService(typeof(IMenuCommandService));
		}

		protected override void WndProc(ref Message msg) 
		{
			base.WndProc(ref msg);
		}
		#endregion


		#region Designer generated code
		private void InitializeComponent()
		{
			components = new System.ComponentModel.Container();
		}
		#endregion
	}
}
