using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using SharpPlus.Action;

namespace ActionDemo
{
	public class ChildForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel plTop;
		private System.Windows.Forms.Button btnShow;
		private SharpPlus.Action.ActionList alActions;
		private SharpPlus.Action.Action actShowMsg;
		private System.Windows.Forms.RichTextBox rtbText;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private SharpPlus.Action.EditClearAction editClearAction1;
		private SharpPlus.Action.EditCopyAction editCopyAction1;
		private SharpPlus.Action.EditCutAction editCutAction1;
		private SharpPlus.Action.EditPasteAction editPasteAction1;
		private SharpPlus.Action.EditSelectAllAction editSelectAllAction1;
		private SharpPlus.Action.EditUndoAction editUndoAction1;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.Button button6;

		private System.ComponentModel.Container components = null;

		public ChildForm()
		{

			InitializeComponent();

		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Designer generated code
		private void InitializeComponent()
		{
			this.plTop = new System.Windows.Forms.Panel();
			this.btnShow = new System.Windows.Forms.Button();
			this.alActions = new SharpPlus.Action.ActionList();
			this.actShowMsg = new SharpPlus.Action.Action();
			this.rtbText = new System.Windows.Forms.RichTextBox();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.editClearAction1 = new SharpPlus.Action.EditClearAction();
			this.editCopyAction1 = new SharpPlus.Action.EditCopyAction();
			this.editCutAction1 = new SharpPlus.Action.EditCutAction();
			this.editPasteAction1 = new SharpPlus.Action.EditPasteAction();
			this.editSelectAllAction1 = new SharpPlus.Action.EditSelectAllAction();
			this.editUndoAction1 = new SharpPlus.Action.EditUndoAction();
			this.button3 = new System.Windows.Forms.Button();
			this.button4 = new System.Windows.Forms.Button();
			this.button6 = new System.Windows.Forms.Button();
			this.plTop.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.alActions)).BeginInit();
			this.SuspendLayout();
			// 
			// plTop
			// 
			this.plTop.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.plTop.Controls.Add(this.button6);
			this.plTop.Controls.Add(this.button4);
			this.plTop.Controls.Add(this.button3);
			this.plTop.Controls.Add(this.button2);
			this.plTop.Controls.Add(this.button1);
			this.plTop.Controls.Add(this.btnShow);
			this.plTop.Dock = System.Windows.Forms.DockStyle.Top;
			this.plTop.Location = new System.Drawing.Point(0, 0);
			this.plTop.Name = "plTop";
			this.plTop.Size = new System.Drawing.Size(672, 56);
			this.plTop.TabIndex = 1;
			// 
			// btnShow
			// 
			this.alActions.SetAction(this.btnShow, this.actShowMsg);
			this.btnShow.Location = new System.Drawing.Point(11, 14);
			this.btnShow.Name = "btnShow";
			this.btnShow.Size = new System.Drawing.Size(93, 27);
			this.btnShow.TabIndex = 0;
			this.btnShow.Text = "Show Message";
			// 
			// alActions
			// 
			this.alActions.Actions.Add(this.actShowMsg);
			this.alActions.Actions.Add(this.editClearAction1);
			this.alActions.Actions.Add(this.editCopyAction1);
			this.alActions.Actions.Add(this.editCutAction1);
			this.alActions.Actions.Add(this.editPasteAction1);
			this.alActions.Actions.Add(this.editSelectAllAction1);
			this.alActions.Actions.Add(this.editUndoAction1);
			// 
			// actShowMsg
			// 
			this.actShowMsg.Caption = "Show Message";
			this.actShowMsg.Tooltip = "Show Message";
			this.actShowMsg.ExecuteAction += new System.EventHandler(this.actShowMsg_ExecuteAction);
			this.actShowMsg.UpdateAction += new System.EventHandler(this.actShowMsg_UpdateAction);
			// 
			// rtbText
			// 
			this.rtbText.Dock = System.Windows.Forms.DockStyle.Fill;
			this.rtbText.Location = new System.Drawing.Point(0, 56);
			this.rtbText.Name = "rtbText";
			this.rtbText.Size = new System.Drawing.Size(672, 350);
			this.rtbText.TabIndex = 2;
			this.rtbText.Text = "";
			// 
			// button1
			// 
			this.alActions.SetAction(this.button1, this.editClearAction1);
			this.button1.Location = new System.Drawing.Point(119, 14);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(93, 27);
			this.button1.TabIndex = 1;
			this.button1.Text = "Clear";
			// 
			// button2
			// 
			this.alActions.SetAction(this.button2, this.editCopyAction1);
			this.button2.Location = new System.Drawing.Point(225, 14);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(93, 27);
			this.button2.TabIndex = 2;
			this.button2.Text = "Copy";
			// 
			// editClearAction1
			// 
			this.editClearAction1.Caption = "Clear";
			this.editClearAction1.Category = "Edit";
			this.editClearAction1.TextBox = this.rtbText;
			// 
			// editCopyAction1
			// 
			this.editCopyAction1.Caption = "Copy";
			this.editCopyAction1.Category = "Edit";
			this.editCopyAction1.ShortCut = System.Windows.Forms.Shortcut.CtrlC;
			this.editCopyAction1.TextBox = this.rtbText;
			// 
			// editCutAction1
			// 
			this.editCutAction1.Caption = "Cut";
			this.editCutAction1.Category = "Edit";
			this.editCutAction1.ShortCut = System.Windows.Forms.Shortcut.CtrlX;
			this.editCutAction1.TextBox = this.rtbText;
			// 
			// editPasteAction1
			// 
			this.editPasteAction1.Caption = "Paste";
			this.editPasteAction1.Category = "Edit";
			this.editPasteAction1.ShortCut = System.Windows.Forms.Shortcut.CtrlV;
			this.editPasteAction1.TextBox = this.rtbText;
			// 
			// editSelectAllAction1
			// 
			this.editSelectAllAction1.Caption = "Select All";
			this.editSelectAllAction1.Category = "Edit";
			this.editSelectAllAction1.ShortCut = System.Windows.Forms.Shortcut.CtrlA;
			this.editSelectAllAction1.TextBox = this.rtbText;
			// 
			// editUndoAction1
			// 
			this.editUndoAction1.Caption = "Undo";
			this.editUndoAction1.Category = "Edit";
			this.editUndoAction1.ShortCut = System.Windows.Forms.Shortcut.CtrlZ;
			this.editUndoAction1.TextBox = this.rtbText;
			// 
			// button3
			// 
			this.alActions.SetAction(this.button3, this.editCutAction1);
			this.button3.Location = new System.Drawing.Point(335, 14);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(93, 27);
			this.button3.TabIndex = 3;
			this.button3.Text = "Cut";
			// 
			// button4
			// 
			this.alActions.SetAction(this.button4, this.editPasteAction1);
			this.button4.Location = new System.Drawing.Point(455, 14);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(93, 27);
			this.button4.TabIndex = 4;
			this.button4.Text = "Paste";
			// 
			// button6
			// 
			this.alActions.SetAction(this.button6, this.editUndoAction1);
			this.button6.Location = new System.Drawing.Point(567, 14);
			this.button6.Name = "button6";
			this.button6.Size = new System.Drawing.Size(93, 27);
			this.button6.TabIndex = 6;
			this.button6.Text = "Undo";
			// 
			// ChildForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(672, 406);
			this.Controls.Add(this.rtbText);
			this.Controls.Add(this.plTop);
			this.Name = "ChildForm";
			this.Text = "Mdi Child";
			this.plTop.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.alActions)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void actShowMsg_UpdateAction(object sender, System.EventArgs e)
		{
			(sender as Action).Enabled=this.rtbText.Text.Trim()!=string.Empty;
		}

		private void actShowMsg_ExecuteAction(object sender, System.EventArgs e)
		{
			MessageBox.Show(this.rtbText.Text.Trim());
		}

		private void plText_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
		
		}
	}
}
